/******************************************************************************************/
/******************************************************************************************/
/*                                                                                        */
/* Trigger: DTULTATU_PRODGRUPROMOC                                                        */
/* Tabela : PRODGRUPROMOC                                                                 */
/*                                                                                        */
/* Criao:                                                                               */
/* 15/09/2008 - Leonardo Matos                                                            */
/*                                                                                        */
/******************************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODGRUPROMOC'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRODGRUPROMOC
GO

CREATE TRIGGER DTULTATU_PRODGRUPROMOC
ON PRODGRUPROMOC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                      (SELECT 'PRODGRUPROMOC', NULL, 'CDGRUPROMOC='+CDGRUPROMOC+
                                                     ';CDPRODUTO='+CDPRODUTO+';', GETDATE() FROM DELETED)
   END ELSE BEGIN
      UPDATE PRODGRUPROMOC
      SET DTULTATUPRPRC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODGRUPROMOC.CDGRUPROMOC,0) = ISNULL(INSERTED.CDGRUPROMOC,0)) AND
            (ISNULL(PRODGRUPROMOC.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0));

            UPDATE PRODUTO
            SET DTULTATUPROD = GETDATE()
            FROM INSERTED
            WHERE PRODUTO.CDPRODUTO  = INSERTED.CDPRODUTO;

            UPDATE PRODOCORRE
            SET DTULTATUPOCO = GETDATE()
            FROM INSERTED
            WHERE PRODOCORRE.CDPRODUTO  = INSERTED.CDPRODUTO; 

            UPDATE PRODLOJA
            SET DTULTATUPLOJ = GETDATE()
            FROM INSERTED
            WHERE PRODLOJA.CDPRODUTO  = INSERTED.CDPRODUTO;

            UPDATE PRODUTOSEG
            SET DTULTATUPSEG = GETDATE()
            FROM INSERTED
            WHERE PRODUTOSEG.CDPRODUTO  = INSERTED.CDPRODUTO; 
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODGRUPROMOC','5.05.023';
GO
